/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_TEST_AUDIO_Controller_PROXY_HPP_
#define V2_TEST_AUDIO_Controller_PROXY_HPP_

#include <v2/Test/Audio/ControllerProxyBase.hpp>


#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/AttributeExtension.hpp>
#include <CommonAPI/Factory.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v2 {
namespace Test {
namespace Audio {

template <typename ... _AttributeExtensions>
class ControllerProxy
    : virtual public Controller,
      virtual public ControllerProxyBase,
      virtual public _AttributeExtensions... {
public:
    ControllerProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~ControllerProxy();

    typedef Controller InterfaceType;


    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

    virtual std::future<void> getCompletionFuture();

    /*
     * description: 
     * test-purposed attribute which is read-write and map data type
     */
    /**
     * Returns the wrapper class that provides access to the attribute IVIDeviceInfo.
     */
    virtual IVIDeviceInfoAttribute& getIVIDeviceInfoAttribute() {
        return delegate_->getIVIDeviceInfoAttribute();
    }
    /*
     * description: 
     * Provides a list of Audio Source Types for ccRC(Rear Seat) System which is provided by the head unit system. 	The list provided to the entire system depending on the resource configuration may be different from the example below.
     * The list has the following format and is a string with upcase letters.
     * -"YOUTUBE_STREAMING"
     * -"TVING_STREAMING"
     * -"WATCHAR_STREAMING"
     */
    /**
     * Returns the wrapper class that provides access to the attribute AudioSourceTypes.
     */
    virtual AudioSourceTypesAttribute& getAudioSourceTypesAttribute() {
        return delegate_->getAudioSourceTypesAttribute();
    }
    /*
     * description: 
     * Contains the Volume Information include min and max levels.
     * The range of these variables depends on each platform specification.
     * -Volume range is defined by audio specification.
     * -MaxSoftVolume is setted by application which has specific requirements for volume limitation.
     * -LastVolume can be used when ccRC need to store current volume by launching specific functions.
     * -Mute notify the current mute status. (true : Mute / false : Unmute)
     */
    /**
     * Returns the wrapper class that provides access to the attribute VolumeInfo.
     */
    virtual VolumeInfoAttribute& getVolumeInfoAttribute() {
        return delegate_->getVolumeInfoAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute KeyValueByteBufferMap.
     */
    virtual KeyValueByteBufferMapAttribute& getKeyValueByteBufferMapAttribute() {
        return delegate_->getKeyValueByteBufferMapAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute DeviceStateMap.
     */
    virtual DeviceStateMapAttribute& getDeviceStateMapAttribute() {
        return delegate_->getDeviceStateMapAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute StringToShortMap.
     */
    virtual StringToShortMapAttribute& getStringToShortMapAttribute() {
        return delegate_->getStringToShortMapAttribute();
    }
    /**
     * description: 
     * The ccRC system requests to obtain audio focus.
     * Calls ObtainFocus with synchronous semantics.
     *
     * All const parameters are input parameters to this method.
     * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void ObtainFocus(std::string _audioSourceType, Controller::AudioDeviceType _device, CommonAPI::CallStatus &_internalCallStatus, Controller::FocusControlError &_error, Controller::AudioFocusResultType &_res, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls ObtainFocus with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> ObtainFocusAsync(const std::string &_audioSourceType, const Controller::AudioDeviceType &_device, ObtainFocusAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * description: 
     * The ccRC system requests to release audio focus.  Requests that cannot be released return errors.
     * Calls ReleaseFocus with synchronous semantics.
     *
     * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void ReleaseFocus(std::string _audioSourceType, Controller::AudioDeviceType _device, CommonAPI::CallStatus &_internalCallStatus, Controller::FocusControlError &_error, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls ReleaseFocus with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> ReleaseFocusAsync(const std::string &_audioSourceType, const Controller::AudioDeviceType &_device, ReleaseFocusAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * description: 
     * Set the volume for outside the system.
     * Calls SetVolume with synchronous semantics.
     *
     * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void SetVolume(uint8_t _volume, CommonAPI::CallStatus &_internalCallStatus, Controller::VolumeControlError &_error, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls SetVolume with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> SetVolumeAsync(const uint8_t &_volume, SetVolumeAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * description: 
     * request to set source volume.
     * There are two member field in the Input parameter.
     * - AudioSourceType: please see "AudioSourceTypes []" for finding detail description
     * - volume : it holds volume level and its level is depending on platform's audio  spec. (varies based on platform, model, misc.)
     * : when this method is invoked, audio manager need to update VolumeInfo.LastVolume
     * 
     * - maxVolume : it defines volume limitation which is described from the requirement
     * - VolumeControlError : please see "setVolume" for more detail explanation
     * Calls SetSourceVolume with synchronous semantics.
     *
     * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void SetSourceVolume(std::string _audioSourceType, uint16_t _volume, uint32_t _maxVolume, CommonAPI::CallStatus &_internalCallStatus, Controller::VolumeControlError &_error, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls SetSourceVolume with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> SetSourceVolumeAsync(const std::string &_audioSourceType, const uint16_t &_volume, const uint32_t &_maxVolume, SetSourceVolumeAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * description: 
     * Get FocusStatus and VolumeInfo for audio source type
     * Calls GetAudioSourceStatus with synchronous semantics.
     *
     * All const parameters are input parameters to this method.
     * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void GetAudioSourceStatus(std::string _audioSourceType, CommonAPI::CallStatus &_internalCallStatus, Controller::ErrorType &_error, Controller::AudioSourceStatusInfo &_audioSourceStatusInfo, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls GetAudioSourceStatus with asynchronous semantics.
     *
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> GetAudioSourceStatusAsync(const std::string &_audioSourceType, GetAudioSourceStatusAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /*
     * description: 
     * broadcast when audio source type changed
     */
    /**
     * Returns the wrapper class that provides access to the broadcast FocusStatusChanged.
     */
    virtual FocusStatusChangedEvent& getFocusStatusChangedEvent() {
        return delegate_->getFocusStatusChangedEvent();
    }



 private:
    std::shared_ptr< ControllerProxyBase> delegate_;
};

typedef ControllerProxy<> ControllerProxyDefault;

namespace ControllerExtensions {
    /*
     * description: 
     * test-purposed attribute which is read-write and map data type
     */
    template <template <typename > class _ExtensionType>
    class IVIDeviceInfoAttributeExtension {
     public:
        typedef _ExtensionType< ControllerProxyBase::IVIDeviceInfoAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension< ControllerProxyBase::IVIDeviceInfoAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    
        IVIDeviceInfoAttributeExtension(ControllerProxyBase& proxy): attributeExtension_(proxy.getIVIDeviceInfoAttribute()) {
        }
    
        inline extension_type& getIVIDeviceInfoAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    /*
     * description: 
     * Provides a list of Audio Source Types for ccRC(Rear Seat) System which is provided by the head unit system. 	The list provided to the entire system depending on the resource configuration may be different from the example below.
     * The list has the following format and is a string with upcase letters.
     * -"YOUTUBE_STREAMING"
     * -"TVING_STREAMING"
     * -"WATCHAR_STREAMING"
     */
    template <template <typename > class _ExtensionType>
    class AudioSourceTypesAttributeExtension {
     public:
        typedef _ExtensionType< ControllerProxyBase::AudioSourceTypesAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension< ControllerProxyBase::AudioSourceTypesAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    
        AudioSourceTypesAttributeExtension(ControllerProxyBase& proxy): attributeExtension_(proxy.getAudioSourceTypesAttribute()) {
        }
    
        inline extension_type& getAudioSourceTypesAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    /*
     * description: 
     * Contains the Volume Information include min and max levels.
     * The range of these variables depends on each platform specification.
     * -Volume range is defined by audio specification.
     * -MaxSoftVolume is setted by application which has specific requirements for volume limitation.
     * -LastVolume can be used when ccRC need to store current volume by launching specific functions.
     * -Mute notify the current mute status. (true : Mute / false : Unmute)
     */
    template <template <typename > class _ExtensionType>
    class VolumeInfoAttributeExtension {
     public:
        typedef _ExtensionType< ControllerProxyBase::VolumeInfoAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension< ControllerProxyBase::VolumeInfoAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    
        VolumeInfoAttributeExtension(ControllerProxyBase& proxy): attributeExtension_(proxy.getVolumeInfoAttribute()) {
        }
    
        inline extension_type& getVolumeInfoAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class KeyValueByteBufferMapAttributeExtension {
     public:
        typedef _ExtensionType< ControllerProxyBase::KeyValueByteBufferMapAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension< ControllerProxyBase::KeyValueByteBufferMapAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    
        KeyValueByteBufferMapAttributeExtension(ControllerProxyBase& proxy): attributeExtension_(proxy.getKeyValueByteBufferMapAttribute()) {
        }
    
        inline extension_type& getKeyValueByteBufferMapAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class DeviceStateMapAttributeExtension {
     public:
        typedef _ExtensionType< ControllerProxyBase::DeviceStateMapAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension< ControllerProxyBase::DeviceStateMapAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    
        DeviceStateMapAttributeExtension(ControllerProxyBase& proxy): attributeExtension_(proxy.getDeviceStateMapAttribute()) {
        }
    
        inline extension_type& getDeviceStateMapAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class StringToShortMapAttributeExtension {
     public:
        typedef _ExtensionType< ControllerProxyBase::StringToShortMapAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension< ControllerProxyBase::StringToShortMapAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    
        StringToShortMapAttributeExtension(ControllerProxyBase& proxy): attributeExtension_(proxy.getStringToShortMapAttribute()) {
        }
    
        inline extension_type& getStringToShortMapAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

} // namespace ControllerExtensions

//
// ControllerProxy Implementation
//
template <typename ... _AttributeExtensions>
ControllerProxy<_AttributeExtensions...>::ControllerProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        _AttributeExtensions(*(std::dynamic_pointer_cast< ControllerProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast< ControllerProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
ControllerProxy<_AttributeExtensions...>::~ControllerProxy() {
}

/*
 * description: 
 * The ccRC system requests to obtain audio focus.
 */
template <typename ... _AttributeExtensions>
void ControllerProxy<_AttributeExtensions...>::ObtainFocus(std::string _audioSourceType, Controller::AudioDeviceType _device, CommonAPI::CallStatus &_internalCallStatus, Controller::FocusControlError &_error, Controller::AudioFocusResultType &_res, const CommonAPI::CallInfo *_info) {
    if (!_device.validate()) {
        _internalCallStatus = CommonAPI::CallStatus::INVALID_VALUE;
        return;
    }
    delegate_->ObtainFocus(_audioSourceType, _device, _internalCallStatus, _error, _res, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> ControllerProxy<_AttributeExtensions...>::ObtainFocusAsync(const std::string &_audioSourceType, const Controller::AudioDeviceType &_device, ObtainFocusAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    if (!_device.validate()) {
        Controller::FocusControlError error;
        Controller::AudioFocusResultType res = Controller::AudioFocusResultType::ALREADY_EXIST;
        _callback(CommonAPI::CallStatus::INVALID_VALUE, error, res);
        std::promise<CommonAPI::CallStatus> promise;
        promise.set_value(CommonAPI::CallStatus::INVALID_VALUE);
        return promise.get_future();
    }
    return delegate_->ObtainFocusAsync(_audioSourceType, _device, _callback, _info);
}
/*
 * description: 
 * The ccRC system requests to release audio focus.  Requests that cannot be released return errors.
 */
template <typename ... _AttributeExtensions>
void ControllerProxy<_AttributeExtensions...>::ReleaseFocus(std::string _audioSourceType, Controller::AudioDeviceType _device, CommonAPI::CallStatus &_internalCallStatus, Controller::FocusControlError &_error, const CommonAPI::CallInfo *_info) {
    if (!_device.validate()) {
        _internalCallStatus = CommonAPI::CallStatus::INVALID_VALUE;
        return;
    }
    delegate_->ReleaseFocus(_audioSourceType, _device, _internalCallStatus, _error, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> ControllerProxy<_AttributeExtensions...>::ReleaseFocusAsync(const std::string &_audioSourceType, const Controller::AudioDeviceType &_device, ReleaseFocusAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    if (!_device.validate()) {
        Controller::FocusControlError error;
        _callback(CommonAPI::CallStatus::INVALID_VALUE, error);
        std::promise<CommonAPI::CallStatus> promise;
        promise.set_value(CommonAPI::CallStatus::INVALID_VALUE);
        return promise.get_future();
    }
    return delegate_->ReleaseFocusAsync(_audioSourceType, _device, _callback, _info);
}
/*
 * description: 
 * Set the volume for outside the system.
 */
template <typename ... _AttributeExtensions>
void ControllerProxy<_AttributeExtensions...>::SetVolume(uint8_t _volume, CommonAPI::CallStatus &_internalCallStatus, Controller::VolumeControlError &_error, const CommonAPI::CallInfo *_info) {
    delegate_->SetVolume(_volume, _internalCallStatus, _error, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> ControllerProxy<_AttributeExtensions...>::SetVolumeAsync(const uint8_t &_volume, SetVolumeAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->SetVolumeAsync(_volume, _callback, _info);
}
/*
 * description: 
 * request to set source volume.
 * There are two member field in the Input parameter.
 * - AudioSourceType: please see "AudioSourceTypes []" for finding detail description
 * - volume : it holds volume level and its level is depending on platform's audio  spec. (varies based on platform, model, misc.)
 * : when this method is invoked, audio manager need to update VolumeInfo.LastVolume
 * 
 * - maxVolume : it defines volume limitation which is described from the requirement
 * - VolumeControlError : please see "setVolume" for more detail explanation
 */
template <typename ... _AttributeExtensions>
void ControllerProxy<_AttributeExtensions...>::SetSourceVolume(std::string _audioSourceType, uint16_t _volume, uint32_t _maxVolume, CommonAPI::CallStatus &_internalCallStatus, Controller::VolumeControlError &_error, const CommonAPI::CallInfo *_info) {
    delegate_->SetSourceVolume(_audioSourceType, _volume, _maxVolume, _internalCallStatus, _error, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> ControllerProxy<_AttributeExtensions...>::SetSourceVolumeAsync(const std::string &_audioSourceType, const uint16_t &_volume, const uint32_t &_maxVolume, SetSourceVolumeAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->SetSourceVolumeAsync(_audioSourceType, _volume, _maxVolume, _callback, _info);
}
/*
 * description: 
 * Get FocusStatus and VolumeInfo for audio source type
 */
template <typename ... _AttributeExtensions>
void ControllerProxy<_AttributeExtensions...>::GetAudioSourceStatus(std::string _audioSourceType, CommonAPI::CallStatus &_internalCallStatus, Controller::ErrorType &_error, Controller::AudioSourceStatusInfo &_audioSourceStatusInfo, const CommonAPI::CallInfo *_info) {
    delegate_->GetAudioSourceStatus(_audioSourceType, _internalCallStatus, _error, _audioSourceStatusInfo, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> ControllerProxy<_AttributeExtensions...>::GetAudioSourceStatusAsync(const std::string &_audioSourceType, GetAudioSourceStatusAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->GetAudioSourceStatusAsync(_audioSourceType, _callback, _info);
}

template <typename ... _AttributeExtensions>
const CommonAPI::Address &ControllerProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool ControllerProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool ControllerProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& ControllerProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& ControllerProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


template <typename ... _AttributeExtensions>
std::future<void> ControllerProxy<_AttributeExtensions...>::getCompletionFuture() {
    return delegate_->getCompletionFuture();
}

} // namespace Audio
} // namespace Test
} // namespace v2

namespace CommonAPI {
template<template<typename > class _AttributeExtension>
struct DefaultAttributeProxyHelper< ::v2::Test::Audio::ControllerProxy,
    _AttributeExtension> {
    typedef typename ::v2::Test::Audio::ControllerProxy<
            ::v2::Test::Audio::ControllerExtensions::IVIDeviceInfoAttributeExtension<_AttributeExtension>, 
            ::v2::Test::Audio::ControllerExtensions::AudioSourceTypesAttributeExtension<_AttributeExtension>, 
            ::v2::Test::Audio::ControllerExtensions::VolumeInfoAttributeExtension<_AttributeExtension>, 
            ::v2::Test::Audio::ControllerExtensions::KeyValueByteBufferMapAttributeExtension<_AttributeExtension>, 
            ::v2::Test::Audio::ControllerExtensions::DeviceStateMapAttributeExtension<_AttributeExtension>, 
            ::v2::Test::Audio::ControllerExtensions::StringToShortMapAttributeExtension<_AttributeExtension>
    > class_t;
};
}


// Compatibility
namespace v2_0 = v2;

#endif // V2_TEST_AUDIO_Controller_PROXY_HPP_
